//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.ComponentEntityApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public partial class GameEntity {

    public SuggestedPositionListenerComponent suggestedPositionListener { get { return (SuggestedPositionListenerComponent)GetComponent(GameComponentsLookup.SuggestedPositionListener); } }
    public bool hasSuggestedPositionListener { get { return HasComponent(GameComponentsLookup.SuggestedPositionListener); } }

    public void AddSuggestedPositionListener(System.Collections.Generic.List<ISuggestedPositionListener> newValue) {
        var index = GameComponentsLookup.SuggestedPositionListener;
        var component = CreateComponent<SuggestedPositionListenerComponent>(index);
        component.value = newValue;
        AddComponent(index, component);
    }

    public void ReplaceSuggestedPositionListener(System.Collections.Generic.List<ISuggestedPositionListener> newValue) {
        var index = GameComponentsLookup.SuggestedPositionListener;
        var component = CreateComponent<SuggestedPositionListenerComponent>(index);
        component.value = newValue;
        ReplaceComponent(index, component);
    }

    public void RemoveSuggestedPositionListener() {
        RemoveComponent(GameComponentsLookup.SuggestedPositionListener);
    }
}

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.ComponentMatcherApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public sealed partial class GameMatcher {

    static Entitas.IMatcher<GameEntity> _matcherSuggestedPositionListener;

    public static Entitas.IMatcher<GameEntity> SuggestedPositionListener {
        get {
            if (_matcherSuggestedPositionListener == null) {
                var matcher = (Entitas.Matcher<GameEntity>)Entitas.Matcher<GameEntity>.AllOf(GameComponentsLookup.SuggestedPositionListener);
                matcher.componentNames = GameComponentsLookup.componentNames;
                _matcherSuggestedPositionListener = matcher;
            }

            return _matcherSuggestedPositionListener;
        }
    }
}

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Entitas.CodeGeneration.Plugins.EventEntityApiGenerator.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------
public partial class GameEntity {

    public void AddSuggestedPositionListener(ISuggestedPositionListener value) {
        var listeners = hasSuggestedPositionListener
            ? suggestedPositionListener.value
            : new System.Collections.Generic.List<ISuggestedPositionListener>();
        listeners.Add(value);
        ReplaceSuggestedPositionListener(listeners);
    }

    public void RemoveSuggestedPositionListener(ISuggestedPositionListener value, bool removeComponentWhenEmpty = true) {
        var listeners = suggestedPositionListener.value;
        listeners.Remove(value);
        if (removeComponentWhenEmpty && listeners.Count == 0) {
            RemoveSuggestedPositionListener();
        } else {
            ReplaceSuggestedPositionListener(listeners);
        }
    }
}
